Index: /branches/NERC/dev_r5549_BDY_ZEROGRAD/NEMOGCM/EXTERNAL/AGRIF/LIB/toamr.c
===================================================================
--- /branches/NERC/dev_r5549_BDY_ZEROGRAD/NEMOGCM/EXTERNAL/AGRIF/LIB/toamr.c	(revision 6807)
+++ /branches/NERC/dev_r5549_BDY_ZEROGRAD/NEMOGCM/EXTERNAL/AGRIF/LIB/toamr.c	(revision 6808)
@@ -656,421 +527,338 @@
    return out;
 }
+
 void write_allocation_Common_0()
 {
-   listnom *parcours_nom;
-   listnom *neededparameter;
-   listvar *parcours;
-   listvar *parcoursprec;
-   listvar *parcours1;
-   FILE *allocationagrif;
-   FILE *paramtoamr;
-   char ligne[LONGNOM];
-   char ligne2[LONGNOM];   
-   variable *v;
-   int IndiceMax;
-   int IndiceMin;
-   int compteur;
-   int out;
-   int indiceprec;
-   int ValeurMax;
-   char initialvalue[LONG_4C];
-   listindice *list_indic;
-   listindice *parcoursindic;
-   int i;
-
-   parcoursprec = (listvar *)NULL;
-   parcours_nom = List_NameOfCommon;
-   ValeurMax = 2;
-   while ( parcours_nom  )
-   {
-      /*                                                                      */
-      if ( parcours_nom->o_val == 1 )
-      {
-         /* Open the file to create the Alloc_agrif subroutine                */
-         sprintf(ligne,"alloc_agrif_%s.h",parcours_nom->o_nom);
-         allocationagrif = associate (ligne);
-         /*                                                                   */
-         fprintf(allocationagrif,"#include \"Param_toamr_%s.h\" \n",
-                                                           parcours_nom->o_nom);
-         /*                                                                   */
-         sprintf(ligne,"Param_toamr_%s.h",parcours_nom->o_nom);
-         paramtoamr = associate (ligne);
-         neededparameter = (listnom * )NULL;
-         /*                                                                   */
-         list_indic = (listindice *)NULL;
-         /*                                                                   */
-         shouldincludempif = 1 ;
-         parcours = List_Common_Var;
-         while ( parcours )
-         {
-            if ( !strcasecmp(parcours->var->v_commonname,parcours_nom->o_nom) &&
-                  IndiceInlist(parcours->var->v_indicetabvars,list_indic) == 0
-               )
+    listnom *parcours_nom;
+    listnom *neededparameter;
+    listvar *parcours;
+    listvar *parcoursprec;
+    listvar *parcours1;
+    FILE *allocationagrif;
+    FILE *paramtoamr;
+    char ligne[LONG_M];
+    char ligne2[LONG_M];
+    variable *v;
+    int IndiceMax;
+    int IndiceMin;
+    int compteur;
+    int out;
+    int indiceprec;
+    int ValeurMax;
+    char initialvalue[LONG_M];
+    listindice **list_indic;
+    listindice *parcoursindic;
+    int i;
+
+    parcoursprec = (listvar *) NULL;
+    parcours_nom = List_NameOfCommon;
+    ValeurMax = 2;
+    while ( parcours_nom  )
+    {
+        if ( parcours_nom->o_val == 1 )
+        {
+            /* Open the file to create the Alloc_agrif subroutine                */
+            sprintf(ligne,"alloc_agrif_%s.h",parcours_nom->o_nom);
+            allocationagrif = open_for_write(ligne);
+            fprintf(allocationagrif,"#include \"Param_toamr_%s.h\" \n", parcours_nom->o_nom);
+
+            sprintf(ligne,"Param_toamr_%s.h",parcours_nom->o_nom);
+            paramtoamr = open_for_write(ligne);
+            neededparameter = (listnom *) NULL;
+            list_indic = (listindice **) calloc(NB_CAT_VARIABLES,sizeof(listindice *));
+
+//             shouldincludempif = 1 ;
+            parcours = List_Common_Var;
+            while ( parcours )
             {
-               /***************************************************************/
-               /***************************************************************/
-               /***************************************************************/
-               v = parcours->var;
-               IndiceMax = 0;
-               IndiceMin = indicemaxtabvars;
-  /* body of the file                                                         */
-  if ( !strcasecmp(v->v_commoninfile,mainfile) )
-  {
-     if (onlyfixedgrids != 1 && v->v_nbdim!=0)
-     {
-        strcpy (ligne, "If (.not. associated(");
-        strcat (ligne, vargridnametabvars(v,0));
-        strcat (ligne, "))                       then");
-        Save_Length(ligne,48);
-        tofich (allocationagrif, ligne,1);
-     }
-     if ( v->v_allocatable != 1 && ( v->v_dimsempty != 1) )
-     {
-        /*                ALLOCATION                                          */
-        if ( v->v_dimension != 0  )
-        {
-           if ( v->v_indicetabvars < IndiceMin ||
-                v->v_indicetabvars > IndiceMax )
-           {
-              parcours1 = parcours;
-              compteur = -1;
-              out = 0;
-              indiceprec = parcours->var->v_indicetabvars -1 ;
-              while ( parcours1 && out == 0 &&
-                      !strcasecmp(  parcours->var->v_readedlistdimension,
-                                  parcours1->var->v_readedlistdimension) &&
-                      !strcasecmp(  parcours->var->v_typevar,
-                                  parcours1->var->v_typevar) &&
-                            ( parcours1->var->v_indicetabvars == indiceprec+1 )
-                     )
-              {
-
-               if ( !strcasecmp(parcours1->var->v_modulename,
-                                parcours_nom->o_nom) ||
-                    !strcasecmp(parcours1->var->v_commonname,
-                                parcours_nom->o_nom) )
-                 {
-                      compteur = compteur +1 ;
-                      indiceprec = parcours1->var->v_indicetabvars;
-                      parcoursprec = parcours1;
-                      parcours1 = parcours1->suiv;
-                 }
-                 else out = 1;
-              }
-
-              if ( compteur > ValeurMax )
-              {
-                 fprintf(allocationagrif,"      DO i = %d , %d\n",
-                                         parcours->var->v_indicetabvars,
-                                       parcours->var->v_indicetabvars+compteur);
-                 IndiceMin = parcours->var->v_indicetabvars;
-                 IndiceMax = parcours->var->v_indicetabvars+compteur;
-                 strcpy (ligne, "allocate ");
-                 strcat (ligne, "(");
-                 strcat (ligne, vargridnametabvars(v,1));
-                 strcat (ligne, vargridparam(v,0));
-                 strcat (ligne, ")");
-                 Save_Length(ligne,48);
-                 tofich (allocationagrif, ligne,1);
-                 fprintf(allocationagrif,"      end do\n");
-                 i=parcours->var->v_indicetabvars;
-                 do
-                 {
-                    parcoursindic =  (listindice *)malloc(sizeof(listindice));
-                    parcoursindic -> i_indice = i;
-                    parcoursindic -> suiv = list_indic;
-                    list_indic = parcoursindic;
-                    i = i + 1;
-                 } while ( i <= parcours->var->v_indicetabvars+compteur );
-                 parcours = parcoursprec;
-                 /*                                                           */
-              }
-              else
-              {
-                 strcpy (ligne, "allocate ");
-                 strcat (ligne, "(");
-                 strcat (ligne, vargridnametabvars(v,0));
-                 strcat (ligne, vargridparam(v,0));
-                 strcat (ligne, ")");
-                 Save_Length(ligne,48);
-                 tofich (allocationagrif, ligne,1);
-                 /*                                                           */
-                 parcoursindic =  (listindice *)malloc(sizeof(listindice));
-                 parcoursindic -> i_indice = parcours->var->v_indicetabvars;
-                 parcoursindic -> suiv = list_indic;
-                 list_indic = parcoursindic;
-              }
-                neededparameter = writedeclarationintoamr(List_Parameter_Var,
-                              paramtoamr,v,parcours_nom->o_nom,neededparameter,
-                                                               v->v_commonname);
-              /*                                                              */
-           }
-        } /* end of the allocation part                                       */
-        /*                INITIALISATION                                      */
-        if ( strcasecmp(v->v_initialvalue,"") )
-        {
-           strcpy (ligne, "");
-           strcat (ligne, vargridnametabvars(v,0));
-           /* We should modify the initialvalue in the case of variable has   */
-           /*    been defined with others variables                           */
-                      
-           strcpy(initialvalue,
-                  ChangeTheInitalvaluebyTabvarsName
-                                      (v->v_initialvalue,List_Global_Var,0));
-           if ( !strcasecmp(initialvalue,v->v_initialvalue) )
-           {
-              strcpy(initialvalue,"");
-              strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName
-                                      (v->v_initialvalue,List_Common_Var,0));
-           }
-           if ( !strcasecmp(initialvalue,v->v_initialvalue) )
-           {
-              strcpy(initialvalue,"");
-              strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName
-                                     (v->v_initialvalue,List_ModuleUsed_Var,0));
-           }
-           strcat (ligne," = ");
-
-           if (v->v_nbdim == 0)
-           {
-           strcpy(ligne2,initialvalue);
-           }
-           else
-           {
-           sprintf(ligne2,"RESHAPE(%s,SHAPE(%s))",initialvalue,vargridnametabvars(v,0));
-           }
-           strcat (ligne,ligne2);
-           /*                                                                 */
-           Save_Length(ligne,48);
-           tofich (allocationagrif, ligne,1);
-        }
-     }
-     if (onlyfixedgrids != 1 && v->v_nbdim!=0)
-     {
-        strcpy (ligne, "   End if");
-        tofich (allocationagrif, ligne,1);
-     }
-  }
-               /***************************************************************/
-               /***************************************************************/
-               /***************************************************************/
+                if ( !strcasecmp(parcours->var->v_commonname,parcours_nom->o_nom) &&
+                    IndiceInlist(parcours->var->v_indicetabvars,list_indic[parcours->var->v_catvar]) == 0 )
+                {
+                    v = parcours->var;
+                    IndiceMax = 0;
+                    IndiceMin = indicemaxtabvars[v->v_catvar];
+                    /* body of the file */
+                    if ( !strcasecmp(v->v_commoninfile,cur_filename) )
+                    {
+                        if ( (onlyfixedgrids != 1) && (v->v_nbdim != 0) )
+                        {
+                            sprintf(ligne,"if (.not. allocated(%s)) then", vargridnametabvars(v,0));
+                            tofich(allocationagrif,ligne,1);
+                        }
+                        if ( (v->v_allocatable != 1) && (v->v_dimsempty != 1) )
+                        {
+                            /*                ALLOCATION                                          */
+                            if ( v->v_dimension != 0 )
+                            {
+                                if ( v->v_indicetabvars < IndiceMin || v->v_indicetabvars > IndiceMax )
+                                {
+                                    parcours1 = parcours;
+                                    compteur = -1;
+                                    out = 0;
+                                    indiceprec = parcours->var->v_indicetabvars -1 ;
+                                    while ( parcours1 && out == 0
+                                        && !strcasecmp(parcours->var->v_readedlistdimension,parcours1->var->v_readedlistdimension)
+                                        && !strcasecmp(parcours->var->v_typevar,            parcours1->var->v_typevar)
+                                        && (parcours1->var->v_indicetabvars == indiceprec+1) )
+                                    {
+                                        if ( !strcasecmp(parcours1->var->v_modulename,parcours_nom->o_nom) ||
+                                             !strcasecmp(parcours1->var->v_commonname,parcours_nom->o_nom) )
+                                        {
+                                            compteur = compteur +1 ;
+                                            indiceprec = parcours1->var->v_indicetabvars;
+                                            parcoursprec = parcours1;
+                                            parcours1 = parcours1->suiv;
+                                        }
+                                        else out = 1;
+                                    }
+                                    sprintf(ligne,"!! ALLOCATION OF VARIABLE : %s",v->v_nomvar);
+                                    tofich(allocationagrif,ligne,1);
+                                    if ( compteur > ValeurMax )
+                                    {
+                                        sprintf(ligne,"do i = %d,%d", parcours->var->v_indicetabvars,
+                                                                      parcours->var->v_indicetabvars+compteur);
+                                        tofich(allocationagrif,ligne,1);
+                                        IndiceMin = parcours->var->v_indicetabvars;
+                                        IndiceMax = parcours->var->v_indicetabvars+compteur;
+                                        sprintf(ligne,"    allocate(%s", vargridnametabvars(v,1));
+                                        sprintf(ligne2,"%s)", vargridparam(v));
+                                        strcat(ligne,ligne2);
+                                        tofich(allocationagrif,ligne,1);
+                                        tofich(allocationagrif,"enddo",1);
+                                        i = parcours->var->v_indicetabvars;
+                                        do
+                                        {
+                                            parcoursindic =  (listindice *)calloc(1,sizeof(listindice));
+                                            parcoursindic -> i_indice = i;
+                                            parcoursindic -> suiv = list_indic[parcours->var->v_catvar];
+                                            list_indic[parcours->var->v_catvar] = parcoursindic;
+                                            i = i + 1;
+                                        } while ( i <= parcours->var->v_indicetabvars+compteur );
+                                        parcours = parcoursprec;
+                                    }
+                                    else
+                                    {
+                                        sprintf(ligne,"allocate(%s", vargridnametabvars(v,0));
+                                        sprintf(ligne2,"%s)", vargridparam(v));
+                                        strcat(ligne,ligne2);
+                                        tofich(allocationagrif,ligne,1);
+                                        parcoursindic =  (listindice *) calloc(1,sizeof(listindice));
+                                        parcoursindic -> i_indice = parcours->var->v_indicetabvars;
+                                        parcoursindic -> suiv = list_indic[parcours->var->v_catvar];
+                                        list_indic[parcours->var->v_catvar] = parcoursindic;
+                                    }
+                                    neededparameter = writedeclarationintoamr(List_Parameter_Var,
+                                                        paramtoamr,v,parcours_nom->o_nom,neededparameter,v->v_commonname);
+                                }
+                            } /* end of the allocation part                                       */
+                            /*                INITIALISATION                                      */
+                            if ( strcasecmp(v->v_initialvalue,"") )
+                            {
+                                strcpy(ligne, vargridnametabvars(v,0));
+                                /* We should modify the initialvalue in the case of variable has been defined with others variables */
+                                strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName(v->v_initialvalue,List_Global_Var));
+                                if ( !strcasecmp(initialvalue,v->v_initialvalue) )
+                                {
+                                    strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName(v->v_initialvalue,List_Common_Var));
+                                }
+                                if ( !strcasecmp(initialvalue,v->v_initialvalue) )
+                                {
+                                    strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName(v->v_initialvalue,List_ModuleUsed_Var));
+                                }
+                                strcat (ligne," = ");
+
+                                if (v->v_nbdim == 0)
+                                {
+                                    strcpy(ligne2,initialvalue);
+                                }
+                                else
+                                {
+                                    sprintf(ligne2,"reshape(%s,shape(%s))",initialvalue,vargridnametabvars(v,0));
+                                }
+                                strcat(ligne,ligne2);
+                                tofich(allocationagrif,ligne,1);
+                            }
+                        }
+                        if ( (onlyfixedgrids != 1) && (v->v_nbdim != 0) )
+                        {
+                            tofich(allocationagrif,"endif",1);
+                        }
+                    }
+                }
+                parcours = parcours -> suiv;
             }
-            parcours = parcours -> suiv;
-         }
-         /* Close the file Alloc_agrif                                        */
-         fclose(allocationagrif);
-         fclose(paramtoamr);
-      }
-      /*                                                                      */
-      parcours_nom = parcours_nom -> suiv;
-   }
-
-}
-
-
+            /* Close the file Alloc_agrif                                        */
+            fclose(allocationagrif);
+            fclose(paramtoamr);
+        }
+        parcours_nom = parcours_nom -> suiv;
+    }
+}
 
 void write_allocation_Global_0()
 {
-   listnom *parcours_nom;
-   listvar *parcours;
-   listvar *parcoursprec;
-   listvar *parcours1;
-   FILE *allocationagrif;
-   char ligne[LONGNOM];
-   variable *v;
-   int IndiceMax;
-   int IndiceMin;
-   int compteur;
-   int out;
-   int indiceprec;
-   int ValeurMax;
-   char initialvalue[LONG_4C];
-   int typeiswritten ;
-
-   parcoursprec = (listvar *)NULL;
-   parcours_nom = List_NameOfModule;
-   ValeurMax = 2;
-   while ( parcours_nom  )
-   {
-      /*                                                                      */
-      if ( parcours_nom->o_val == 1 )
-      {
-         IndiceMax = 0;
-         IndiceMin = indicemaxtabvars;
-         /* Open the file to create the Alloc_agrif subroutine                */
-         sprintf(ligne,"alloc_agrif_%s.h",parcours_nom->o_nom);
-         allocationagrif = associate (ligne);
-         /*                                                                   */
-         if ( ModuleIsDefineInInputFile(parcours_nom->o_nom) == 1 )
-         {
-             /* add the call to initworkspace                                 */
-            tofich(allocationagrif,"if ( .NOT. Agrif_Root() ) then ",1);
-            fprintf(allocationagrif,"#include \"GetNumberofcells.h\" \n");
-            tofich(allocationagrif,"else ",1);
-            fprintf(allocationagrif,"#include \"SetNumberofcells.h\" \n");
-            tofich(allocationagrif,"endif ",1);
-            tofich(allocationagrif,"Call Agrif_InitWorkspace ",1);
-         }
-
-         typeiswritten = 0;
-
-         parcours = List_Global_Var;
-         while ( parcours )
-         {
-            if ( !strcasecmp(parcours->var->v_modulename,parcours_nom->o_nom) &&
-                 parcours->var->v_VariableIsParameter == 0                  &&
-                 parcours->var->v_notgrid == 0                              &&
-                 !strcasecmp(parcours->var->v_modulename,parcours_nom->o_nom)  )
+    listnom *parcours_nom;
+    listvar *parcours;
+    listvar *parcoursprec;
+    listvar *parcours1;
+    FILE *allocationagrif;
+    char ligne[LONG_M];
+    char ligne2[LONG_M];
+    variable *v;
+    int IndiceMax;
+    int IndiceMin;
+    int compteur;
+    int out;
+    int indiceprec;
+    int ValeurMax;
+    char initialvalue[LONG_M];
+    int typeiswritten ;
+
+    parcoursprec = (listvar *) NULL;
+    parcours_nom = List_NameOfModule;
+    ValeurMax = 2;
+
+    while ( parcours_nom  )
+    {
+        if ( parcours_nom->o_val == 1 )
+        {
+            IndiceMax = 0;
+            IndiceMin = indicemaxtabvars[0];
+            /* Open the file to create the Alloc_agrif subroutine                */
+            sprintf(ligne,"alloc_agrif_%s.h",parcours_nom->o_nom);
+            allocationagrif = open_for_write(ligne);
+
+//             if ( ModuleIsDefineInInputFile(parcours_nom->o_nom) == 1 )
+//             {
+//                 /* add the call to initworkspace         */
+//                 tofich(allocationagrif,"if (.not. Agrif_Root() ) then",1);
+//                 tofich(allocationagrif,"#include \"GetNumberofcells.h\"\n",0);
+//                 tofich(allocationagrif,"else",1);
+//                 tofich(allocationagrif,"#include \"SetNumberofcells.h\"\n",0);
+//                 tofich(allocationagrif,"endif",1);
+//                 tofich(allocationagrif,"call Agrif_InitWorkspace",1);
+//             }
+
+            typeiswritten = 0;
+            parcours = List_Global_Var;
+            while ( parcours )
             {
-               /***************************************************************/
-               /***************************************************************/
-               /***************************************************************/
-               v = parcours->var;
-               IndiceMax = 0;
-               IndiceMin = indicemaxtabvars;
-  /* body of the file                                                         */
-  if ( !strcasecmp(v->v_commoninfile,mainfile) )
-  {
-     if (onlyfixedgrids != 1 && v->v_nbdim!=0)
-     {
-        strcpy (ligne, "If (.not. associated(");
-        strcat (ligne, vargridnametabvars(v,0));
-        strcat (ligne, "))                       then");
-        Save_Length(ligne,48);
-        tofich (allocationagrif, ligne,1);
-     }
-     if ( v->v_allocatable != 1 && ( v->v_dimsempty != 1) )
-     {
-        /*                ALLOCATION                                          */
-        if ( v->v_dimension != 0  )
-        {
-           if ( v->v_indicetabvars < IndiceMin ||
-                v->v_indicetabvars > IndiceMax )
-           {
-              parcours1 = parcours;
-              compteur = -1;
-              out = 0;
-              indiceprec = parcours->var->v_indicetabvars -1 ;
-              while ( parcours1 && out == 0 &&
-                      !strcasecmp(  parcours->var->v_readedlistdimension,
-                                  parcours1->var->v_readedlistdimension) &&
-                      !strcasecmp(  parcours->var->v_typevar,
-                                  parcours1->var->v_typevar) &&
-                             ( parcours1->var->v_indicetabvars == indiceprec+1 )
-                     )
-              {
-
-               if ( !strcasecmp(parcours1->var->v_modulename,
-                                parcours_nom->o_nom) ||
-                    !strcasecmp(parcours1->var->v_commonname,
-                                parcours_nom->o_nom) )
-                 {
-                      compteur = compteur +1 ;
-                      indiceprec = parcours1->var->v_indicetabvars;
-                      parcoursprec = parcours1;
-                      parcours1 = parcours1->suiv;
-                 }
-                 else out = 1;
-              }
-              if ( compteur > ValeurMax )
-              {
-                 fprintf(allocationagrif,"      DO i = %d , %d\n",
-                                          parcours->var->v_indicetabvars,
-                                       parcours->var->v_indicetabvars+compteur);
-                 IndiceMin = parcours->var->v_indicetabvars;
-                 IndiceMax = parcours->var->v_indicetabvars+compteur;
-                 strcpy (ligne, "allocate ");
-                 strcat (ligne, "(");
-                 strcat (ligne, vargridnametabvars(v,1));
-                 strcat (ligne, vargridparam(v,0));
-                 strcat (ligne, ")");
-                 Save_Length(ligne,48);
-                 tofich (allocationagrif, ligne,1);
-                 fprintf(allocationagrif,"      end do\n");
-                 parcours = parcoursprec;
-              }
-              else
-              {
-                 strcpy (ligne, "allocate ");
-                 strcat (ligne, "(");
-                 strcat (ligne, vargridnametabvars(v,0));
-                 strcat (ligne, vargridparam(v,0));
-                 strcat (ligne, ")");
-                 Save_Length(ligne,48);
-                 tofich (allocationagrif, ligne,1);
-              }
-           }
-        } /* end of the allocation part                                       */
-
-        /*                INITIALISATION                                      */
-        if ( strcasecmp(v->v_initialvalue,"") )
-        {
-           strcpy (ligne, "");
-           strcat (ligne, vargridnametabvars(v,0));
-           /* We should modify the initialvalue in the case of variable has   */
-           /*    been defined with others variables                           */
-
-           strcpy(initialvalue,
-                  ChangeTheInitalvaluebyTabvarsName
-                                      (v->v_initialvalue,List_Global_Var,0));
-           if ( !strcasecmp(initialvalue,v->v_initialvalue) )
-           {
-              strcpy(initialvalue,"");
-              strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName
-                                      (v->v_initialvalue,List_Common_Var,0));
-           }
-           if ( !strcasecmp(initialvalue,v->v_initialvalue) )
-           {
-              strcpy(initialvalue,"");
-              strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName
-                                     (v->v_initialvalue,List_ModuleUsed_Var,0));
-           }
-           strcat (ligne," = ");
-           strcat (ligne,initialvalue);
-           /*                                                                 */
-           Save_Length(ligne,48);
-           tofich (allocationagrif, ligne,1);
-        }
-     }
-/* Case of structure types */
-        if ((typeiswritten == 0) && !strcasecmp(v->v_typevar,"type"))
-        {
-        sprintf(ligne,"If (.Not.Allocated(Agrif_%s_var)) Then",v->v_modulename);
-        tofich(allocationagrif, ligne, 1);
-        sprintf(ligne,"Allocate(Agrif_%s_var(0:Agrif_NbMaxGrids))",v->v_modulename);
-        tofich(allocationagrif, ligne, 1);
-        strcpy(ligne,"End If");
-        tofich(allocationagrif, ligne, 1);
-        typeiswritten = 1;
-        }
-     if (onlyfixedgrids != 1 && v->v_nbdim!=0)
-     {
-        strcpy (ligne, "   End if");
-        tofich (allocationagrif, ligne,1);
-     }
-  }
-               /***************************************************************/
-               /***************************************************************/
-               /***************************************************************/
+                if ( !strcasecmp(parcours->var->v_modulename,parcours_nom->o_nom) &&
+                       parcours->var->v_VariableIsParameter == 0                  &&
+                       parcours->var->v_notgrid == 0  )
+                {
+                    v = parcours->var;
+                    IndiceMax = 0;
+                    IndiceMin = indicemaxtabvars[v->v_catvar];
+                    /* body of the file */
+                    if ( !strcasecmp(v->v_commoninfile,cur_filename) )
+                    {
+                        if ( (onlyfixedgrids != 1) && (v->v_nbdim != 0) )
+                        {
+                            sprintf(ligne,"if (.not. allocated(%s)) then", vargridnametabvars(v,0));
+                            tofich(allocationagrif,ligne,1);
+                        }
+                        if ( (v->v_allocatable != 1) && (v->v_dimsempty != 1) )
+                        {
+                            /*                ALLOCATION                                          */
+                            if ( v->v_dimension != 0 )
+                            {
+                                if ( v->v_indicetabvars < IndiceMin || v->v_indicetabvars > IndiceMax )
+                                {
+                                    parcours1 = parcours;
+                                    compteur = -1;
+                                    out = 0;
+                                    indiceprec = parcours->var->v_indicetabvars -1 ;
+                                    while ( parcours1 && out == 0
+                                        && !strcasecmp(parcours->var->v_readedlistdimension,parcours1->var->v_readedlistdimension)
+                                        && !strcasecmp(parcours->var->v_typevar,            parcours1->var->v_typevar)
+                                        && (parcours1->var->v_indicetabvars == indiceprec+1) )
+                                    {
+                                        if ( !strcasecmp(parcours1->var->v_modulename, parcours_nom->o_nom) ||
+                                             !strcasecmp(parcours1->var->v_commonname, parcours_nom->o_nom) )
+                                        {
+                                            compteur = compteur +1 ;
+                                            indiceprec = parcours1->var->v_indicetabvars;
+                                            parcoursprec = parcours1;
+                                            parcours1 = parcours1->suiv;
+                                        }
+                                        else out = 1;
+                                    }
+                                    sprintf(ligne,"!! ALLOCATION OF VARIABLE : %s",v->v_nomvar);
+                                    tofich(allocationagrif,ligne,1);
+                                    if ( compteur > ValeurMax )
+                                    {
+                                        sprintf(ligne,"do i = %d,%d", parcours->var->v_indicetabvars,
+                                                                      parcours->var->v_indicetabvars+compteur);
+                                        tofich(allocationagrif,ligne,1);
+                                        IndiceMin = parcours->var->v_indicetabvars;
+                                        IndiceMax = parcours->var->v_indicetabvars+compteur;
+                                        sprintf(ligne,"    allocate(%s", vargridnametabvars(v,1));
+                                        sprintf(ligne2,"%s)", vargridparam(v));
+                                        strcat(ligne,ligne2);
+                                        tofich(allocationagrif,ligne,1);
+                                        tofich(allocationagrif,"enddo",1);
+                                        parcours = parcoursprec;
+                                    }
+                                    else
+                                    {
+                                        sprintf(ligne,"allocate(%s", vargridnametabvars(v,0));
+                                        sprintf(ligne2,"%s)", vargridparam(v));
+                                        strcat(ligne,ligne2);
+                                        tofich(allocationagrif,ligne,1);
+                                    }
+                                }
+                            } /* end of the allocation part                                       */
+                            /*                INITIALISATION                                      */
+                            if ( strcasecmp(v->v_initialvalue,"") )
+                            {
+                                strcpy(ligne, vargridnametabvars(v,0));
+                                /* We should modify the initialvalue in the case of variable has been defined with others variables */
+                                strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName(v->v_initialvalue,List_Global_Var));
+                                if ( !strcasecmp(initialvalue,v->v_initialvalue) )
+                                {
+                                    strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName(v->v_initialvalue,List_Common_Var));
+                                }
+                                if ( !strcasecmp(initialvalue,v->v_initialvalue) )
+                                {
+                                    strcpy(initialvalue,ChangeTheInitalvaluebyTabvarsName(v->v_initialvalue,List_ModuleUsed_Var));
+                                }
+                                strcat (ligne," = ");
+                                strcat (ligne,initialvalue);
+                                Save_Length(ligne,48);
+                                tofich(allocationagrif,ligne,1);
+                            }
+                        }
+                        /* Case of structure types */
+                        if ( (typeiswritten == 0) && !strcasecmp(v->v_typevar,"type") )
+                        {
+                            sprintf(ligne,"if (.not. allocated(Agrif_%s_var)) then",v->v_modulename);
+                            tofich(allocationagrif, ligne, 1);
+                            sprintf(ligne,"    allocate(Agrif_%s_var(0:Agrif_NbMaxGrids))",v->v_modulename);
+                            tofich(allocationagrif, ligne, 1);
+                            tofich(allocationagrif, "endif", 1);
+                            typeiswritten = 1;
+                        }
+                        if ( (onlyfixedgrids != 1) && (v->v_nbdim != 0) )
+                        {
+                            tofich(allocationagrif,"endif",1);
+                        }
+                    }
+                }
+                parcours = parcours -> suiv;
             }
-            parcours = parcours -> suiv;
-         }
-         /*                                                                   */
-         if ( ModuleIsDefineInInputFile(parcours_nom->o_nom) == 1 )
-         {
-            /* add the call to initworkspace                                  */
-            tofich(allocationagrif,"if ( .NOT. Agrif_Root() ) then ",1);
-            fprintf(allocationagrif,"#include \"GetNumberofcells.h\" \n");
-            tofich(allocationagrif,"else ",1);
-            fprintf(allocationagrif,"#include \"SetNumberofcells.h\" \n");
-            tofich(allocationagrif,"endif ",1);
-            tofich(allocationagrif,"Call Agrif_InitWorkspace ",1);
-         }
-         /* Close the file Alloc_agrif                                        */
-         fclose(allocationagrif);
-      } /* end parcours_nom == 1                                              */
-      /*                                                                      */
-      parcours_nom = parcours_nom -> suiv;
-   }
+            if ( ModuleIsDefineInInputFile(parcours_nom->o_nom) == 1 )
+            {
+                fprintf(allocationagrif, "      if ( .not.Agrif_Root() ) then\n");
+                fprintf(allocationagrif, "#include \"GetNumberofcells.h\"\n");
+                fprintf(allocationagrif, "      else\n");
+                fprintf(allocationagrif, "#include \"SetNumberofcells.h\"\n");
+                fprintf(allocationagrif, "      endif\n");
+                fprintf(allocationagrif, "      call Agrif_InitWorkspace\n");
+            }
+            fclose(allocationagrif);
+        }
+        parcours_nom = parcours_nom -> suiv;
+    }
 }
 
